## WCMCommander-0.20.0.tar.gz

=== CMakeLists.txt ===
PROJECT(wcm)
CMAKE_MINIMUM_REQUIRED(VERSION 2.8)
SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake)

ADD_SUBDIRECTORY(src)

=== src/CMakeLists.txt ===
# platform-specific options and dependencies
IF(MINGW)
	# libssh2 is bundled, others are not needed
	SET(wcm_LIBS gdi32 wsock32 mpr)
ELSE(MINGW)
	FIND_PACKAGE(Threads)
	FIND_PACKAGE(X11)

	OPTION(WITH_FREETYPE "Enable freetype support" ON)
	OPTION(WITH_LIBSSH2 "Enable libssh2 support" ON)

	IF(MSVC)
		OPTION(WITH_SMBCLIENT "Enable samba support" OFF)
	ELSE(MSVC)
		OPTION(WITH_SMBCLIENT "Enable samba support" ON)
	ENDIF(MSVC)

	INCLUDE_DIRECTORIES(${X11_X11_INCLUDE_PATH})
	SET(wcm_LIBS ${CMAKE_THREAD_LIBS_INIT} ${X11_X11_LIB})

	IF(WITH_FREETYPE)
		FIND_PACKAGE(Freetype)
		IF(NOT ${FREETYPE_FOUND})
			MESSAGE(FATAL_ERROR "Freetype not found. You should either install it or disable WITH_FREETYPE cmake option")
		ENDIF(NOT ${FREETYPE_FOUND})
		ADD_DEFINITIONS(-DUSEFREETYPE)
		INCLUDE_DIRECTORIES(${FREETYPE_INCLUDE_DIRS})
		SET(wcm_LIBS ${wcm_LIBS} ${FREETYPE_LIBRARIES})
		MESSAGE(STATUS "Freetype support enabled")
	ELSE(WITH_FREETYPE)
		MESSAGE(STATUS "Freetype support disabled")
	ENDIF(WITH_FREETYPE)

	IF(WITH_LIBSSH2)
		FIND_PACKAGE(SSH2)
		IF(NOT ${SSH2_FOUND})
			MESSAGE(FATAL_ERROR "libssh2 not found. You should either install it or disable WITH_LIBSSH2 cmake option")
		ENDIF(NOT ${SSH2_FOUND})
		ADD_DEFINITIONS(-DLIBSSH2_EXIST)
		INCLUDE_DIRECTORIES(${SSH2_INCLUDE_DIR})
		SET(wcm_LIBS ${wcm_LIBS} ${SSH2_LIBRARY})
		MESSAGE(STATUS "libssh2 support enabled")
	ELSE(WITH_LIBSSH2)
		MESSAGE(STATUS "libssh2 support disabled")
	ENDIF(WITH_LIBSSH2)

	IF(WITH_SMBCLIENT)
		FIND_PACKAGE(SMBClient)
		IF(NOT ${SMBCLIENT_FOUND})
			MESSAGE(FATAL_ERROR "libsmbclient not found. You should either install it or disable WITH_SMBCLIENT cmake option")
		ENDIF(NOT ${SMBCLIENT_FOUND})
		ADD_DEFINITIONS(-DLIBSMBCLIENT_EXIST)
		INCLUDE_DIRECTORIES(${SMBCLIENT_INCLUDE_DIR})
		SET(wcm_LIBS ${wcm_LIBS} ${SMBCLIENT_LIBRARY})
		MESSAGE(STATUS "smbclient support enabled")
	ELSE(WITH_SMBCLIENT)
		MESSAGE(STATUS "smbclient support disabled")
	ENDIF(WITH_SMBCLIENT)
ENDIF(MINGW)

# flags
SET(BINDIR bin CACHE STRING "directory where to install binary files")
SET(DESKTOPDIR share/applications CACHE STRING "directory where to install .desktop files")
SET(PIXMAPDIR share/pixmaps CACHE STRING "directory where to install pixmaps")
SET(DATADIR share/wcm CACHE STRING "directory where to install data")

CONFIGURE_FILE(libconf_ux.h.in libconf_ux.h) # noop, flags are passed via compiler args
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES(BEFORE wal swl vfs utf8proc .)
ADD_DEFINITIONS(-D_FILE_OFFSET_BITS=64)
ADD_DEFINITIONS(-DUNIX_CONFIG_DIR_PATH="${CMAKE_INSTALL_PREFIX}/${DATADIR}")

IF(MSVC)
	INCLUDE_DIRECTORIES(../libssh2)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /EHsc /RTCc /RTC1 /GS /GR /Oy /Qpar /MP /MTd")
	SET(CMAKE_EXE_LINKER_FLAGS "/SUBSYSTEM:WINDOWS /NODEFAULTLIB:libcmt /ignore:4099")
	SET(wcm_LIBS
		${wcm_LIBS}
		Ws2_32
		Mpr
		../../libssh2/static32/libssh2
		../../libssh2/static32/ssleay32
		../../libssh2/static32/libeay32
		../../libssh2/static32/zlib
	)

ELSE(MSVC)
	SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -Wall -Wextra -Wno-unused-parameter -Wno-unknown-pragmas")
ENDIF(MSVC)

# sources
IF(MINGW OR MSVC)
	SET(wcm_PLATFORM_SOURCES
		ext-app-win.cpp
		swl/swl_wincoreMS.cpp
		w32cons.cpp
		w32util.cpp
	)
ELSE(MINGW OR MSVC)
	SET(wcm_PLATFORM_SOURCES
		ext-app-ux.cpp
		fontdlg.cpp
		shell.cpp
		swl/swl_wincoreUX.cpp
		terminal.cpp
		utf8proc/utf8proc.c
	)
ENDIF(MINGW OR MSVC)

SET(wcm_COMMON_SOURCES
	nc.cpp
	panel.cpp

	charsetdlg.cpp
	color-style.cpp
	dircalc.cpp
	dlg-ctrl-l.cpp
	eloadsave.cpp
	globals.cpp
	fileassociations.cpp
	fileattributes.cpp
	filehighlighting.cpp
	fileopers.cpp
	filesearch.cpp
	ftplogon.cpp
	help.cpp
	helpres.cpp
	ltext.cpp
	ncdialogs.cpp
	ncedit.cpp
	ncfonts.cpp
	nchistory.cpp
	ncview.cpp
	ncwin.cpp
	operthread.cpp
	operwin.cpp
	panel.cpp
	panel_list.cpp
	search-dlg.cpp
	search-tools.cpp
	sftpdlg.cpp
	shell-tools.cpp
	shl.cpp
	path-list.cpp
	folder-shortcuts.cpp
	folder-history.cpp
	view-history.cpp
	drive-dlg.cpp
	file-util.cpp
	file-exec.cpp
	nceditline.cpp
	smblogon.cpp
	strconfig.cpp
	string-util.cpp
	strmasks.cpp
	swl/swl_button.cpp
	swl/swl_editline.cpp
	swl/swl_combobox.cpp
	swl/swl_layout.cpp
	swl/swl_menubox.cpp
	swl/swl_menutextinfo.cpp
	swl/swl_popupmenu.cpp
	swl/swl_sbutton.cpp
	swl/swl_scrollbar.cpp
	swl/swl_staticlabel.cpp
	swl/swl_textlist.cpp
	swl/swl_vlist.cpp
	swl/swl_winbase.cpp
	swl/swl_wincore.cpp
	t-emulator.cpp
	tcp_sock.cpp
	termwin.cpp
	toolbar.cpp
	unicode_lc.cpp
	usermenu.cpp
	ux_util.cpp
	vfs/vfs-ftp.cpp
	vfs/vfs-sftp2.cpp
	vfs/vfs-smb.cpp
	vfs/vfs-tmp.cpp
	vfs/vfs-uri.cpp
	vfs/vfs.cpp
	vfs/vfspath.cpp
	wal/wal.cpp
	wal/wal_charset.cpp
	wal/wal_exceptions.cpp
	wal/wal_files.cpp
	wal/wal_sys_api.cpp
	wal/wal_tmpls.cpp
	wcm-config.cpp
	urlparser/LUrlParser.cpp
)

SET(wcm_HEADERS
	charsetdlg.h
	color-style.h
	dircalc.h
	dlg-ctrl-l.h
	eloadsave.h
	ext-app.h
	globals.h
	fileassociations.h
	fileattributes.h
	filehighlighting.h
	fileopers.h
	filesearch.h
	fontdlg.h
	ftplogon.h
	help.h
	libconf.h
	ltext.h
	mfile.h
	nc.h
	ncdialogs.h
	ncedit.h
	ncfonts.h
	nchistory.h
	ncview.h
	ncwin.h
	operthread.h
	operwin.h
	panel.h
	panel_list.h
	search-dlg.h
	search-tools.h
	sftpdlg.h
	shell-tools.h
	shell.h
	shl.h
	path-list.h
	folder-shortcuts.h
	folder-history.h
	view-history.h
	drive-dlg.h
	file-util.h
	file-exec.h
	nceditline.h
	smblogon.h
	strconfig.h
	string-util.h
	swl/swl.h
	swl/swl_internal.h
	swl/swl_layout.h
	swl/swl_winbase.h
	swl/swl_wincore.h
	swl/swl_wincore_internal.h
	t-emulator.h
	tcp_sock.h
	terminal.h
	termwin.h
	toolbar.h
	usermenu.h
	ux_util.h
	vfs/vfs-ftp.h
	vfs/vfs-sftp.h
	vfs/vfs-smb.h
	vfs/vfs-tmp.h
	vfs/vfs-uri.h
	vfs/vfs.h
	vfs/vfspath.h
	wal/wal.h
	wal/wal_sys_api.h
	wal/wal_tmpls.h
	wcm-config.h
	urlparser/LUrlParser.h
)

SET(wcm_RESOURCES
	wcm.rc
)

# targets
ADD_EXECUTABLE(wcm ${wcm_COMMON_SOURCES} ${wcm_PLATFORM_SOURCES} ${wcm_HEADERS} ${wcm_RESOURCES})
TARGET_LINK_LIBRARIES(wcm ${wcm_LIBS})

# install
IF(NOT MSVC)
	INSTALL(TARGETS wcm RUNTIME DESTINATION ${BINDIR})
	INSTALL(FILES ${PROJECT_SOURCE_DIR}/install-files/share/applications/wcm.desktop DESTINATION ${DESKTOPDIR})
	INSTALL(FILES ${PROJECT_SOURCE_DIR}/install-files/share/pixmaps/wcm.png DESTINATION ${PIXMAPDIR})
	INSTALL(DIRECTORY ${PROJECT_SOURCE_DIR}/install-files/share/wcm/ DESTINATION ${DATADIR})
ENDIF(NOT MSVC)

# groups
IF(MSVC)
	SET(wcm_ALL_FILES
		${wcm_COMMON_SOURCES}
		${wcm_PLATFORM_SOURCES}
		${wcm_HEADERS}
		${wcm_RESOURCES}
	)
	MACRO(SETUP_SOURCE_GROUPS SRC_FILES)
		FOREACH(FILE ${SRC_FILES}) 
			GET_FILENAME_COMPONENT(PARENT_DIR "${FILE}" PATH)
			STRING(REGEX REPLACE "(\\./)?(src|include)/?" "" GROUP "${PARENT_DIR}")
			STRING(REPLACE "/" "\\" GROUP "${GROUP}")
			IF ("${FILE}" MATCHES ".*\\.cpp")
				SET(GROUP "Source Files\\${GROUP}")
			ELSEIF("${FILE}" MATCHES ".*\\.h")
				SET(GROUP "Header Files\\${GROUP}")
			ELSEIF("${FILE}" MATCHES ".*\\.rc")
				SET(GROUP "Windows Resources\\${GROUP}")
			ENDIF()
			SOURCE_GROUP("${GROUP}" FILES "${FILE}")
		ENDFOREACH()
	ENDMACRO()
	SETUP_SOURCE_GROUPS("${wcm_ALL_FILES}")
ENDIF(MSVC)

=== debian/changelog ===
wcm (0.20.0-1) stable; urgency=medium
  * Project renamed to WCM Commander
  * Added #345: External color schemes
  * Added #375: File attributes: modification of creation/modification/access time
  * Added #462: Open files on non-local file systems
  * Added #379: Inheriting the current dir from a parent process (options --load-current-dir and --dont-load-current-dir)
  * Added: history and autocomplete in all edit lines
  * Added: view history
  * Added: OS X volumes are shown in the Drive dialog
  * Hotkey: F4 on a folder opens the Attributes dialog
  * Imrpoved #352: Space acts as Enter when a button has focus
  * Improved #388: Do not discard editor undo history when saving a file
  * Improved #435: User menu: allow references to selected files
  * Improved: rendering of long file names is faster
  * Improved: Ctrl+G in the editor accepts any values
  * Imrpoved: keyboard shortcuts for file sorting modes in the main menu
  * Fixed #306: Submenu detaches after Alt-Tab
  * Fixed #309: After clicking one tool button, all toolbuttons lose tooltips
  * Fixed #319: Use antialiased fonts everywhere except the menubar
  * Fixed #400: When a command is executed, reset the 'last command' index for Ctrl-E/Ctrl-X
  * Fixed #401: Ctrl-Ins on a panel should copy all the selected file names to a clipboard
  * Fixed #402: Shift-Enter on folders
  * Fixed #407: 'Case sensitive' checkbox (in the Find dialog) is not always preserved
  * Fixed #421: Files with single|double|back-quotes in the name should now open fine with 'Enter'
  * Fixed #436: Temporary panel shows ".." even if displaying of ".." is disabled in "Panel Settings"
  * Fixed #436: Cursor position is being retained after diving in, and returning back from a temp panel
  * Fixed #440: Parasitic key in the Ctrl+L dialog
  * Fixed #443: File view/edit history doesn't work for temp panel items
  * Fixed #444: File disapears from the temp panel after editing
  * Fixed #458: OS X: CMD+C not working for command line in panel mode
  * Fixed #471: Linux: Hotkeys conflict in select drive dialog
  * Fixed #472: Attribure-based coloring/icons are not rendered on temporary panel
  * Fixed #473: Cannot go into the first folder under the (S)FTP/SMB root folder
  * Fixed #476: Windows: SFTP entry is missing in drive dialog
  * Fixed #479: Windows: segfault on exit when launched from Cygwin/MinGW terminal (mintty)
  * Fixed: Recalculate layouts after closing the help dialog
  * Development: CMake generates proper folders for MSVC projects

 -- Sergey Kosarevsky <sk@linderdaum.com>  Sat, 21 Feb 2015 23:44:06 -0500

wcm (0.19.0.1-1) stable; urgency=medium
  * Fixed: crash on Linux/OSX if bad UTF-8 sequence is encountered in a file name

 -- Sergey Kosarevsky <sk@linderdaum.com>  Sat, 21 Feb 2015 23:44:06 -0500

wcm (0.19.0-1) stable; urgency=medium
  * Added: Shift+Enter opens a file/folder with the default OS application
  * Added: bookmarks in the editor (set via RightCtrl+digit, restore via LeftCtrl+digit)
  * Added: adjust font size with Ctrl+WheelUp, Ctrl+WheelDn (Windows-only)
  * Added: basic SSH keys SFTP authorization
  * Added: temporary panel
  * Added: mark truncated file names with the '}' symbol in panels
  * Added: store FTP passwords between sessions
  * Added: folders history (Alt+F12)
  * Added: file attributes dialog (Ctrl+A)
  * Added: command line autocompletion shows file/folder names from the current folder
  * Added: pressing F3 on '..' calculates the size of the current folder
  * Added: typing in the viewer opens the search dialog
  * Added: maximize window (Alt+F9)
  * Hotkey: Ctrl+Alt+Ins, Alt+Shift+Ins, Ctrl+Shift+P to copy the full path of the currently selected item to the clipboard
  * Hotkey: Ctrl+R to refresh the drives list in the drive selection dialog
  * Hotkey: Ctrl+NumPadPlus, Ctrl+NumPadMinus to select and deselect files with the same extension
  * Improved: 'cd' in the command line without arguments should change directory to $HOME
  * Improved: hotkeys in the F2 user menu
  * Improved: hotkeys in all 'red' dialogs
  * Improved: retain cursor position after F5/F6 etc.
  * Improved: rendering of folders with unicode names (normalized unicode strings)
  * Improved: C++11 highlighting in the editor
  * Fixed: button bar text in the editor
  * Fixed: hotkeys in the 'Styles' dialog
  * Fixed: OpenBSD support
  * Fixed: installation issues
  * Fixed: TrueType fonts antialiasing
  * Fixed: debug messages in the console
  * Fixed: mouse interaction bugs
  * Fixed: graphical issue in the current path under the panels
  * Fixed: hide the autocompletion window while switching via Ctrl+Tab to the editor/viewer
  * Fixed: panel width after exiting the editor with Ctrl+Tab
  * Fixed: pressing Alt+key freezes Ctrl/Shift info in the bottom bar
  * Fixed: custom highlighting rules for selected files
  * Fixed: shortcuts in the text search/replace dialogs
  * Fixed: long path truncation in the drive selection dialog
  * Fixed: selection color in the viewer

 -- Sergey Kosarevsky <sk@linderdaum.com>  Sat, 21 Feb 2015 23:44:06 -0500

wcm (0.18.1-1) unstable; urgency=medium
  * Added: file highlighting
  * Added: speed indicator while copying
  * Added: color and icon (optional) for soft links
  * Added: copy multiple selected file names to the clipboard
  * Added: option to disable setup auto saving
  * Added: option to show/hide the main menu
  * Added: show '(Administrator)' in the window caption while running with admin privileges on Windows
  * Added: show volume label in the drive selection dialog
  * Added: user menu (F2)
  * Added: status bar for Alt+... keys in the aditor
  * Hotkey: Ctrl+L to open info dialog
  * Hotkey: Ctrl+S to select file (same as Ins)
  * Hotkey: Ctrl+F12 to select sorting mode
  * Improved: eye-gouging borders in the main menu
  * Improved: icons centering in the panels
  * Fixed: hotkeys in the drive selection dialog
  * Fixed: up/down in Alt-search
  * Fixed: numpad Ins and numpad Del


=== debian/control ===
Source: wcm
Section: unknown
Priority: optional
Maintainer: Sergey Kosarevsky <sk@linderdaum.com>
Build-Depends: debhelper (>= 8.0.0), libfreetype6-dev, libsmbclient-dev, libssh2-1-dev, libx11-dev, build-essential
Standards-Version: 3.9.4
Homepage: https://github.com/corporateshark/WCMCommander
#Vcs-Git: git://git.debian.org/collab-maint/wcm.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/wcm.git;a=summary

Package: wcm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: WCM Commander dual panel file manager.
 The purpose of this project is to create a multi-platform open source dual panel file manager
 (Windows, Linux, FreeBSD, OS X) mimicking the look-n-feel of Far Manager.
 Currently WCM Commander runs on Windows, Linux and FreeBSD.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#DH_VERBOSE = 1

# see EXAMPLES in dpkg-buildflags(1) and read /usr/share/dpkg/*
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk
 
# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# main packaging script based on dh7 syntax
%:
	dh $@
